#ifndef PLUGINSCHEDULER_H
#define PLUGINSCHEDULER_H

#ifndef IN_SCHEDULER_CODE
typedef void * plugins_scheduler_t;
#else

struct hash {
	char * name;
	struct arglist * plugin;
	struct hash * next;
	};

struct list {
	char * name;
	struct arglist * plugin;
	struct list * next;
	struct list * prev;
	};
	
struct plugins_scheduler_struct {
	struct hash * hash;
	struct list * list;
	int simul;
	};
	
typedef struct plugins_scheduler_struct * plugins_scheduler_t;

#endif


#define PLUG_RUNNING ((struct arglist*)0x02)
#define PLUGIN_STATUS_UNRUN 	1
#define PLUGIN_STATUS_RUNNING	2
#define PLUGIN_STATUS_DONE	3



void plugin_set_running_state(struct arglist * , int);


plugins_scheduler_t plugins_scheduler_init(struct arglist*, int, int);
struct arglist * plugins_scheduler_next(plugins_scheduler_t);

void plugins_scheduler_free(plugins_scheduler_t);

#endif
